# Overview

InfluxDB is an open-source, distributed, time series database.

# Usage with Telegraf

Deploy the telegraf charm, and the required InfluxDB charm with the following:

    juju deploy telegraf
    juju deploy cs:~influxdb-charmers/influxdb

Add the relation between the two charms:

    juju add-relation influxdb telegraf

# Usage with Grafana

Deploy the Grafana charm, and the required InfluxDB charm with the following:

    juju deploy grafana
    juju deploy cs:~influxdb-charmers/influxdb

Add the relation between the two charms:

    juju add-relation influxdb:grafana-source grafana:grafana-source

The relationship will automatically register the InfluxDB instance as a
data source in Grafana.

However, you still need to create an InfluxDB database and populate the
Grafana data source page with its details. Once you have created an
InfluxDB database, visit the Grafana /datasources page, choose your
InfluxDB juju generated data source, and edit the database settings
accordingly.

# Authentication

To enable authentication, add "http.auth-enabled=true" to
extra_configs, e.g., if there are no other options set:

    juju config influxdb extra_configs="- http.auth-enabled=true"

Whether authentication is enabled or not, the charm will create an
"admin" account at install time and store the credentials in
`/root/.influx-auth`.  If the application is related to cs:nrpe, it
will create a "nagios" account and store the credentials in
`/var/lib/nagios/.influx-auth`, as the Nagios check expects.
Due to the way the check works, this is also an admin account.

All other authentication management must be done manually, including
to allow a related grafana access to use an InfluxDB data source.

# Notes

An earlier version of this charm contained .deb and .tar.gz files
for InfluxDB and Python dependencies. They have been removed from
the git repository, so you will need to ensure you are using an up
to date clone of the codebase before making any changes.
